## mingw-w64-restbed-4.8-3.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.1.0 FATAL_ERROR )

project( "restbed" VERSION 4.7.0 LANGUAGES CXX )
message( "                                                              " )
message( "##############################################################" )
message( "#                                                            #" )
message( "#  Copyright 2013-2020, Corvusoft Ltd, All Rights Reserved.  #" )
message( "#                                                            #" )
message( "#  Restbed is dual-licensed requiring commerical entities    #" )
message( "#  to acquire a Corvusoft Permissive License, Contact        #" )
message( "#  sales@corvusoft.co.uk for details.                        #" )
message( "#                                                            #" )
message( "##############################################################" )
message( "                                                              " )

#
# Build Options
#
option( BUILD_TESTS "Build unit tests." ON )
option( BUILD_SSL "Build secure socket layer support." ON )
option( BUILD_IPC "Build unix domain socket layer support." OFF )

#
# Configuration
#
set( CMAKE_CXX_STANDARD 14 )
set( INCLUDE_DIR "${PROJECT_SOURCE_DIR}/source" )
set( SOURCE_DIR  "${PROJECT_SOURCE_DIR}/source/corvusoft/${PROJECT_NAME}" )

if ( NOT DEFINED CMAKE_INSTALL_LIBDIR )
    set( CMAKE_INSTALL_LIBDIR "library")
endif ( )

if ( CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
    set( CMAKE_INSTALL_PREFIX "${PROJECT_SOURCE_DIR}/distribution" CACHE PATH "Install path prefix" FORCE )
endif ( )

if( ${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D_WIN32_WINNT=0x0601 /W4 /wd4068 /wd4702 /wd4996 /wd4265" )
endif ( )

if( NOT WIN32 )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Weffc++ -pedantic -Wno-unknown-pragmas -Wno-deprecated-declarations -Wno-non-virtual-dtor" )
endif ( )

if ( UNIX AND NOT APPLE )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread" )
endif ( )

if ( APPLE )
    set( CMAKE_MACOSX_RPATH ON )
endif ( )

set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake" )

find_package( asio REQUIRED )

if ( BUILD_SSL )
    add_definitions( "-DBUILD_SSL" )
    find_package( openssl REQUIRED )
endif ( )

include_directories( ${INCLUDE_DIR} SYSTEM ${asio_INCLUDE} ${ssl_INCLUDE} )

if ( BUILD_IPC )
    add_definitions( "-DBUILD_IPC" )
endif ( )

if ( WIN32 )
	add_definitions( -DWIN_DLL_EXPORT )
	set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251" )
endif ( )

#
# Build
#
file( GLOB_RECURSE MANIFEST "${SOURCE_DIR}/*.cpp" )

set( STATIC_LIBRARY_NAME "${PROJECT_NAME}-static" )
add_library( ${STATIC_LIBRARY_NAME} STATIC ${MANIFEST} )
set_property( TARGET ${STATIC_LIBRARY_NAME} PROPERTY CXX_STANDARD 14 )
set_property( TARGET ${STATIC_LIBRARY_NAME} PROPERTY CXX_STANDARD_REQUIRED ON )
set_target_properties( ${STATIC_LIBRARY_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME} )
	
set( SHARED_LIBRARY_NAME "${PROJECT_NAME}-shared" )
add_library( ${SHARED_LIBRARY_NAME} SHARED ${MANIFEST} )
set_property( TARGET ${SHARED_LIBRARY_NAME} PROPERTY CXX_STANDARD 14 )
set_property( TARGET ${SHARED_LIBRARY_NAME} PROPERTY CXX_STANDARD_REQUIRED ON )
if ( WIN32 )
	# Workaround to avoid name clash of static lib and dynamic import lib under windows.
	set_target_properties( ${SHARED_LIBRARY_NAME} PROPERTIES OUTPUT_NAME "${PROJECT_NAME}-shared" )
else ( )
	set_target_properties( ${SHARED_LIBRARY_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME} )
endif ( )	
set_target_properties( ${SHARED_LIBRARY_NAME} PROPERTIES SOVERSION ${PROJECT_VERSION_MAJOR} VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR} )

if ( BUILD_SSL )
    target_link_libraries( ${SHARED_LIBRARY_NAME} LINK_PRIVATE ${ssl_LIBRARY_SHARED} ${crypto_LIBRARY_SHARED} )
    target_link_libraries( ${STATIC_LIBRARY_NAME} LINK_PRIVATE ${ssl_LIBRARY_STATIC} ${crypto_LIBRARY_STATIC} ${CMAKE_DL_LIBS} )
else ( )
    target_link_libraries( ${SHARED_LIBRARY_NAME} )
    target_link_libraries( ${STATIC_LIBRARY_NAME} ${CMAKE_DL_LIBS} )
endif ( )

if ( BUILD_TESTS )
    find_package( catch REQUIRED )

    enable_testing( )
    add_subdirectory( "${PROJECT_SOURCE_DIR}/test/unit" )
    add_subdirectory( "${PROJECT_SOURCE_DIR}/test/feature" )
    add_subdirectory( "${PROJECT_SOURCE_DIR}/test/regression" )
    add_subdirectory( "${PROJECT_SOURCE_DIR}/test/integration" )
endif ( )

#
# Install
#
file( GLOB ARTIFACTS "${SOURCE_DIR}/*.hpp" )

install( FILES "${INCLUDE_DIR}/${PROJECT_NAME}" DESTINATION "${CMAKE_INSTALL_PREFIX}/include" )
install( FILES ${ARTIFACTS} DESTINATION "${CMAKE_INSTALL_PREFIX}/include/corvusoft/${PROJECT_NAME}" )
install( TARGETS ${STATIC_LIBRARY_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT library )
install( TARGETS ${SHARED_LIBRARY_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT library )

=== test/feature/CMakeLists.txt ===
project( "feature test suite" )

cmake_minimum_required( VERSION 3.1.0 FATAL_ERROR )

#
# Configuration
#
set( SOURCE_DIR "source" )
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCATCH_CONFIG_MAIN" )

include_directories( SYSTEM ${catch_INCLUDE} ${asio_INCLUDE} )

#
# Build
#
add_executable( publishing_single_path_resources_http_get_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_get.cpp )
target_link_libraries( publishing_single_path_resources_http_get_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_get_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_get_feature_test_suite )

add_executable( publishing_single_path_resources_http_put_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_put.cpp )
target_link_libraries( publishing_single_path_resources_http_put_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_put_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_put_feature_test_suite )

add_executable( publishing_single_path_resources_http_head_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_head.cpp )
target_link_libraries( publishing_single_path_resources_http_head_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_head_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_head_feature_test_suite )

add_executable( publishing_single_path_resources_http_post_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_post.cpp )
target_link_libraries( publishing_single_path_resources_http_post_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_post_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_post_feature_test_suite )

add_executable( publishing_single_path_resources_http_trace_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_trace.cpp )
target_link_libraries( publishing_single_path_resources_http_trace_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_trace_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_trace_feature_test_suite )

add_executable( publishing_single_path_resources_http_patch_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_patch.cpp )
target_link_libraries( publishing_single_path_resources_http_patch_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_patch_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_patch_feature_test_suite )

add_executable( publishing_single_path_resources_http_delete_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_delete.cpp )
target_link_libraries( publishing_single_path_resources_http_delete_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_delete_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_delete_feature_test_suite )

add_executable( publishing_single_path_resources_http_connect_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_connect.cpp )
target_link_libraries( publishing_single_path_resources_http_connect_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_connect_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_connect_feature_test_suite )

add_executable( publishing_single_path_resources_http_options_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_options.cpp )
target_link_libraries( publishing_single_path_resources_http_options_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_options_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_options_feature_test_suite )

add_executable( publishing_multi_path_resources_http_get_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_get.cpp )
target_link_libraries( publishing_multi_path_resources_http_get_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_get_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_get_feature_test_suite )

add_executable( publishing_multi_path_resources_http_put_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_put.cpp )
target_link_libraries( publishing_multi_path_resources_http_put_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_put_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_put_feature_test_suite )

add_executable( publishing_multi_path_resources_http_head_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_head.cpp )
target_link_libraries( publishing_multi_path_resources_http_head_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_head_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_head_feature_test_suite )

add_executable( publishing_multi_path_resources_http_post_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_post.cpp )
target_link_libraries( publishing_multi_path_resources_http_post_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_post_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_post_feature_test_suite )

add_executable( publishing_multi_path_resources_http_trace_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_trace.cpp )
target_link_libraries( publishing_multi_path_resources_http_trace_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_trace_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_trace_feature_test_suite )

add_executable( publishing_multi_path_resources_http_patch_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_patch.cpp )
target_link_libraries( publishing_multi_path_resources_http_patch_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_patch_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_patch_feature_test_suite )

add_executable( publishing_multi_path_resources_http_delete_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_delete.cpp )
target_link_libraries( publishing_multi_path_resources_http_delete_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_delete_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_delete_feature_test_suite )

add_executable( publishing_multi_path_resources_http_connect_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_connect.cpp )
target_link_libraries( publishing_multi_path_resources_http_connect_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_connect_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_connect_feature_test_suite )

add_executable( publishing_multi_path_resources_http_options_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_options.cpp )
target_link_libraries( publishing_multi_path_resources_http_options_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_options_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_options_feature_test_suite )

add_executable( custom_http_methods_http_get_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_get.cpp )
target_link_libraries( custom_http_methods_http_get_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_get_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_get_feature_test_suite )

add_executable( custom_http_methods_http_put_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_put.cpp )
target_link_libraries( custom_http_methods_http_put_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_put_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_put_feature_test_suite )

add_executable( custom_http_methods_http_head_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_head.cpp )
target_link_libraries( custom_http_methods_http_head_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_head_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_head_feature_test_suite )

add_executable( custom_http_methods_http_post_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_post.cpp )
target_link_libraries( custom_http_methods_http_post_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_post_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_post_feature_test_suite )

add_executable( custom_http_methods_http_trace_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_trace.cpp )
target_link_libraries( custom_http_methods_http_trace_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_trace_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_trace_feature_test_suite )

add_executable( custom_http_methods_http_patch_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_patch.cpp )
target_link_libraries( custom_http_methods_http_patch_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_patch_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_patch_feature_test_suite )

add_executable( custom_http_methods_http_delete_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_delete.cpp )
target_link_libraries( custom_http_methods_http_delete_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_delete_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_delete_feature_test_suite )

add_executable( custom_http_methods_http_connect_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_connect.cpp )
target_link_libraries( custom_http_methods_http_connect_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_connect_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_connect_feature_test_suite )

add_executable( custom_http_methods_http_options_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_options.cpp )
target_link_libraries( custom_http_methods_http_options_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_options_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_options_feature_test_suite )

add_executable( custom_http_methods_http_invoke_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_invoke.cpp )
target_link_libraries( custom_http_methods_http_invoke_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_invoke_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_invoke_feature_test_suite )

add_executable( http_method_handlers_http_get_feature_test_suite ${SOURCE_DIR}/http_method_handlers/http_get.cpp )
target_link_libraries( http_method_handlers_http_get_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( http_method_handlers_http_get_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/http_method_handlers_http_get_feature_test_suite )

add_executable( http_method_handlers_http_put_feature_test_suite ${SOURCE_DIR}/http_method_handlers/http_put.cpp )
target_link_libraries( http_method_handlers_http_put_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( http_method_handlers_http_put_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/http_method_handlers_http_put_feature_test_suite )

=== PKGBUILD ===
# Maintainer: Markus Rathgeb <maggu2810@gmail.com>

_realname=restbed
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=4.8
pkgrel=3
pkgdesc="Corvusoft's Restbed framework brings asynchronous RESTful functionality to C++14 applications (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/Corvusoft/restbed"
license=('spdx:AGPL-3.0-only')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-openssl")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-asio")
source=("https://github.com/Corvusoft/restbed/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0001-fix-CMakeLists.txt.patch"
        "0002-fix-dll-import-export-instructions.patch"
        "0003-fix-asio-deprecated-symbols.patch")
sha256sums=('4801833f86a67b8a123c2c01203e259eb81157e1e9ef144a3b6395cb2d838a42'
            'a4f3bea758d595aad69a1e59417da02646509509ef78e7f92e87afe93e1226c5'
            '0f8f1f8564b0c82bd591bfea1de199e8be04cc7cfd57c01f049e319dcec72201'
            '59c50653879eaeaf946ae88a188fe075ecdf384f6bea3038c057c8753c76541f')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  patch -Np1 -i "${srcdir}/0001-fix-CMakeLists.txt.patch"
  patch -Np1 -i "${srcdir}/0002-fix-dll-import-export-instructions.patch"
  patch -Np1 -i "${srcdir}/0003-fix-asio-deprecated-symbols.patch"
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
      "${_extra_config[@]}" \
      -DBUILD_TESTS=OFF \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

check() {
  # Shared Check
  cd "${srcdir}/build-${MSYSTEM}"
  PATH=$PWD/src:$PATH ${MINGW_PREFIX}/bin/ctest.exe ./ || true
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .

  # License
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/legal/LICENSE* -t "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/
}
